// -*- C++ -*-
/*!
 * @file DirectInPortBase.h
 * @brief DirectInPortBase class
 * @date $Date: 2018-1-23 03:08:05 $
 * @author Nobuhiko Miyamoto <n-miyamoto@aist.go.jp>
 *
 * Copyright (C) 2018
 *     Nobuhiko Miyamoto
 *     National Institute of
 *         Advanced Industrial Science and Technology (AIST), Japan
 *     All rights reserved.
 *
 *
 */

#ifndef RTC_DIRECTINPORTBASE_H
#define RTC_DIRECTINPORTBASE_H



#include <coil/Mutex.h>
#include <rtm/DirectPortBase.h>



namespace RTC
{
	/*!
	* @if jp
	* @class DirectInPortBase
	* @brief directڑpInPortNX
	*
	*
	* @since 1.2.0
	*
	* @else
	* @class DirectOutPortBase
	* @brief
	*
	*
	*
	* @since 1.2.0
	*
	* @endif
	*/
  template <class DataType>
  class DirectInPortBase : public DirectPortBase
  {
  public:
	  /*!
	  * @if jp
	  * @brief RXgN^
	  *
	  * @param value
	  *
	  * @else
	  * @brief Constructor
	  *
	  * @param value
	  *
	  * @endif
	  */
    DirectInPortBase(DataType& value)
    {
    }
    
	/*!
	* @if jp
	* @brief fXgN^
	*
	*
	* @else
	* @brief Destructor
	*
	*
	* @endif
	*/
    virtual ~DirectInPortBase(void){};



    
    /*!
     * @if jp
     *
     * @brief ŐVf[^݂邩mF
     * 
     * InPortɖǂ̍ŐVf[^Ă邩boollŕԂB
     * InPortڑ̏ꍇAѐڑRlN^̃obt@Empty
     * ̏ꍇɂfalseԂB
     *
     * @return true ǂ̍ŐVf[^݂
     *         false ڑ܂̓obt@Ƀf[^݂ȂB
     * 
     * @else
     *
     * @brief Check whether the data is newest
     * 
     * Check whether the data stored at a current buffer position is newest.
     *
     * @return Newest data check result
     *         ( true:Newest data. Data has not been readout yet.
     *          false:Past dataDData has already been readout.)
     * 
     * @endif
     */
    virtual bool isNew()
    {
		return false;
    }

    /*!
     * @if jp
     *
     * @brief obt@󂩂ǂmF
     * 
     * InPort̃obt@󂩂ǂ bool lŕԂB
     * ̏ꍇ true, ǃf[^ꍇ false ԂB
     *
     * @return true  obt@͋
     *         false obt@ɖǃf[^
     * 
     * @else
     *
     * @brief Check whether the data is newest
     * 
     * Check whether the data stored at a current buffer position is newest.
     *
     * @return Newest data check result
     *         ( true:Newest data. Data has not been readout yet.
     *          false:Past dataDData has already been readout.)
     * 
     * @endif
     */
    virtual bool isEmpty()
    {
		return true;
    }

	/*!
	* @if jp
	* @brief f[^̏
	*
	* @param data f[^
	*
	* @else
	* @brief
	*
	* @param data
	*
	* @endif
	*/
    virtual void write(const DataType& data)
    {
    }


  protected:
    

  };
}; // End of namesepace RTM

#endif // RTC_DIRECTINPORTBASE_H
