// -*- C++ -*-
/*!
 * @file ManagerActionListener.cpp
 * @brief Component action listener class
 * @date $Date$
 * @author Noriaki Ando <n-ando@aist.go.jp>
 *
 * Copyright (C) 2011
 *     Noriaki Ando
 *     Intelligent Systems Research Institute,
 *     National Institute of
 *         Advanced Industrial Science and Technology (AIST), Japan
 *     All rights reserved.
 *
 * $Id$
 *
 */

#include <rtm/ManagerActionListener.h>

namespace RTM
{
  
  //============================================================
  /*!
   * @if jp
   * @class ManagerActionListener NX
   * @else
   * @class ManagerActionListener class
   * @endif
   */
  ManagerActionListener::~ManagerActionListener()
  {
  }
  
  /*!
   * @if jp
   * @class ManagerActionListenerHolder NX
   * @else
   * @class ManagerActionListenerHolder class
   * @endif
   */
  ManagerActionListenerHolder::~ManagerActionListenerHolder()
  {
  }
  
  /*!
   * @if jp
   * @brief preShutdown R[obN֐
   * TODO: Documentation
   * @else
   * @brief preShutdown callback function
   * TODO: Documentation
   * @endif
   */
  void ManagerActionListenerHolder::preShutdown()
  {
    LISTENERHOLDER_CALLBACK(preShutdown, ());
  }
  
  /*!
   * @if jp
   * @brief postShutdown R[obN֐
   * TODO: Documentation
   * @else
   * @brief postShutdown callback function
   * TODO: Documentation
   * @endif
   */
  void ManagerActionListenerHolder::postShutdown()
  {
    LISTENERHOLDER_CALLBACK(postShutdown, ());
  }
  
  /*!
   * @if jp
   * @brief preReinit R[obN֐
   * TODO: Documentation
   * @else
   * @brief preReinit callback function
   * TODO: Documentation
   * @endif
   */
  void ManagerActionListenerHolder::preReinit()
  {
    LISTENERHOLDER_CALLBACK(preReinit, ());
  }
  
  /*!
   * @if jp
   * @brief postReinit R[obN֐
   * TODO: Documentation
   * @else
   * @brief postReinit callback function
   * TODO: Documentation
   * @endif
   */
  void ManagerActionListenerHolder::postReinit()
  {
    LISTENERHOLDER_CALLBACK(postReinit, ());
  }
  
  
  //============================================================
  /*!
   * @if jp
   * @class ModuleActionListener NX
   * @else
   * @class ModuleActionListener class
   * @endif
   */
  ModuleActionListener::~ModuleActionListener()
  {
  }
  
  /*!
   * @if jp
   * @class ModuleActionListener z_NX
   * @else
   * @class ModuleActionListener holder class
   * @endif
   */
  ModuleActionListenerHolder::~ModuleActionListenerHolder()
  {
  }
  
  /*!
   * @if jp
   * @brief preLoad R[obN֐
   * TODO: Documentation
   * @else
   * @brief preLoad callback function
   * TODO: Documentation
   * @endif
   */
  void ModuleActionListenerHolder::preLoad(std::string& modname,
                                           std::string& funcname)
  {
    LISTENERHOLDER_CALLBACK(preLoad, (modname, funcname));
  }
  
  /*!
   * @if jp
   * @brief postLoad R[obN֐
   * TODO: Documentation
   * @else
   * @brief postLoad callback function
   * TODO: Documentation
   * @endif
   */
  void ModuleActionListenerHolder::postLoad(std::string& modname,
                                            std::string& funcname)
  {
    LISTENERHOLDER_CALLBACK(postLoad, (modname, funcname));
  }
  
  /*!
   * @if jp
   * @brief preUnload R[obN֐
   * TODO: Documentation
   * @else
   * @brief preUnload callback function
   * TODO: Documentation
   * @endif
   */
  void ModuleActionListenerHolder::preUnload(std::string& modname)
  {
    LISTENERHOLDER_CALLBACK(preUnload, (modname));
  }
  
  /*!
   * @if jp
   * @brief postUnload R[obN֐
   * TODO: Documentation
   * @else
   * @brief postUnload callback function
   * TODO: Documentation
   * @endif
   */
  void ModuleActionListenerHolder::postUnload(std::string& modname)
  {
    LISTENERHOLDER_CALLBACK(postUnload, (modname));
  }
  
  
  //============================================================
  /*!
   * @if jp
   * @class RtcLifecycleActionListener NX
   * @brief RtcLifecycleActionListener NX
   * @else
   * @class RtcLifecycleActionListener class
   * @brief RtcLifecycleActionListener class
   * @endif
   */
  RtcLifecycleActionListener::~RtcLifecycleActionListener()
  {
  }
  
  /*!
   * @if jp
   * @brief fXgN^
   * @else
   * @brief Destructor
   * @endif
   */
  RtcLifecycleActionListenerHolder::~RtcLifecycleActionListenerHolder()
  {
  }
  
  /*!
   * @if jp
   * @brief preCreate R[obN֐
   * TODO: Documentation
   * @else
   * @brief preCreate callback function
   * TODO: Documentation
   * @endif
   */
  void RtcLifecycleActionListenerHolder::preCreate(std::string& args)
  {
    LISTENERHOLDER_CALLBACK(preCreate, (args));
  }
  
  /*!
   * @if jp
   * @brief postCreate R[obN֐
   * TODO: Documentation
   * @else
   * @brief postCreate callback function
   * TODO: Documentation
   * @endif
   */
  void RtcLifecycleActionListenerHolder::postCreate(RTC::RTObject_impl* rtobj)
  {
    LISTENERHOLDER_CALLBACK(postCreate, (rtobj));
  }
  
  /*!
   * @if jp
   * @brief preConfigure R[obN֐
   * TODO: Documentation
   * @else
   * @brief preConfigure callback function
   * TODO: Documentation
   * @endif
   */
  void RtcLifecycleActionListenerHolder::preConfigure(coil::Properties& prop)
  {
    LISTENERHOLDER_CALLBACK(preConfigure, (prop));
  }
  
  /*!
   * @if jp
   * @brief postConfigure R[obN֐
   * TODO: Documentation
   * @else
   * @brief postConfigure callback function
   * TODO: Documentation
   * @endif
   */
  void RtcLifecycleActionListenerHolder::postConfigure(coil::Properties& prop)
  {
    LISTENERHOLDER_CALLBACK(postConfigure, (prop));
  }
  
  /*!
   * @if jp
   * @brief preInitialize R[obN֐
   * TODO: Documentation
   * @else
   * @brief preInitialize callback function
   * TODO: Documentation
   * @endif
   */
  void RtcLifecycleActionListenerHolder::preInitialize(void)
  {
    LISTENERHOLDER_CALLBACK(preInitialize, ());
  }
  
  /*!
   * @if jp
   * @brief postInitialize R[obN֐
   * TODO: Documentation
   * @else
   * @brief postInitialize callback function
   * TODO: Documentation
   * @endif
   */
  void RtcLifecycleActionListenerHolder::postInitialize(void)
  {
    LISTENERHOLDER_CALLBACK(postInitialize, ());
  }
  
  
  //============================================================
  /*!
   * @if jp
   * @brief fXgN^
   * @else
   * @brief Destructor
   * @endif
   */
  NamingActionListener::~NamingActionListener()
  {
  }
  
  /*!
   * @if jp
   * @brief fXgN^
   * @else
   * @brief Destructor
   * @endif
   */
  NamingActionListenerHolder::~NamingActionListenerHolder()
  {
  }
  
  /*!
   * @if jp
   * @brief preBind R[obN֐
   * TODO: Documentation
   * @else
   * @brief preBind callback function
   * TODO: Documentation
   * @endif
   */
  void NamingActionListenerHolder::preBind(RTC::RTObject_impl* rtobj,
                                           coil::vstring& name)
  {
    LISTENERHOLDER_CALLBACK(preBind, (rtobj, name));
  }
  
  /*!
   * @if jp
   * @brief postBind R[obN֐
   * TODO: Documentation
   * @else
   * @brief postBind callback function
   * TODO: Documentation
   * @endif
   */
  void NamingActionListenerHolder::postBind(RTC::RTObject_impl* rtobj,
                                            coil::vstring& name)
  {
    LISTENERHOLDER_CALLBACK(postBind, (rtobj, name));
  }
  
  /*!
   * @if jp
   * @brief preUnbind R[obN֐
   * TODO: Documentation
   * @else
   * @brief preUnbind callback function
   * TODO: Documentation
   * @endif
   */
  void NamingActionListenerHolder::preUnbind(RTC::RTObject_impl* rtobj,
                                             coil::vstring& name)
  {
    LISTENERHOLDER_CALLBACK(preUnbind, (rtobj, name));
  }
  
  /*!
   * @if jp
   * @brief postUnbind R[obN֐
   * TODO: Documentation
   * @else
   * @brief postUnbind callback function
   * TODO: Documentation
   * @endif
   */
  void NamingActionListenerHolder::postUnbind(RTC::RTObject_impl* rtobj,
                                              coil::vstring& name)
  {
    LISTENERHOLDER_CALLBACK(postUnbind, (rtobj, name));
  }
  
  
  //============================================================
  /*!
   * @if jp
   * @brief fXgN^
   * @else
   * @brief Destructor
   * @endif
   */
  LocalServiceActionListener::~LocalServiceActionListener()
  {
  }
  
  /*!
   * @if jp
   * @brief fXgN^
   * @else
   * @brief Destructor
   * @endif
   */
  LocalServiceActionListenerHolder::~LocalServiceActionListenerHolder()
  {
  }
  
  /*!
   * @if jp
   * @brief preServiceRegister R[obN֐
   * TODO: Documentation
   * @else
   * @brief preServiceRegister callback function
   * TODO: Documentation
   * @endif
   */
  void LocalServiceActionListenerHolder::
  preServiceRegister(std::string service_name)
  {
    LISTENERHOLDER_CALLBACK(preServiceRegister, (service_name));
  }
  
  /*!
   * @if jp
   * @brief postServiceRegister R[obN֐
   * TODO: Documentation
   * @else
   * @brief postServiceRegister callback function
   * TODO: Documentation
   * @endif
   */
  void LocalServiceActionListenerHolder::
  postServiceRegister(std::string service_name, RTM::LocalServiceBase* service)
  {
    LISTENERHOLDER_CALLBACK(postServiceRegister, (service_name, service));
  }
  
  /*!
   * @if jp
   * @brief preServiceInit R[obN֐
   * TODO: Documentation
   * @else
   * @brief preServiceInit callback function
   * TODO: Documentation
   * @endif
   */
  void LocalServiceActionListenerHolder::
  preServiceInit(coil::Properties& prop, RTM::LocalServiceBase* service)
  {
    LISTENERHOLDER_CALLBACK(preServiceInit, (prop, service));
  }
  
  /*!
   * @if jp
   * @brief postServiceInit R[obN֐
   * TODO: Documentation
   * @else
   * @brief postServiceInit callback function
   * TODO: Documentation
   * @endif
   */
  void LocalServiceActionListenerHolder::
  postServiceInit(coil::Properties& prop, RTM::LocalServiceBase* service)
  {
    LISTENERHOLDER_CALLBACK(postServiceInit, (prop, service));
  }
  
  /*!
   * @if jp
   * @brief preServiceReinit R[obN֐
   * TODO: Documentation
   * @else
   * @brief preServiceReinit callback function
   * TODO: Documentation
   * @endif
   */
  void LocalServiceActionListenerHolder::
  preServiceReinit(coil::Properties& prop, RTM::LocalServiceBase* service)
  {
    LISTENERHOLDER_CALLBACK(preServiceReinit, (prop, service));
  }
  
  /*!
   * @if jp
   * @brief postServiceReinit R[obN֐
   * TODO: Documentation
   * @else
   * @brief postServiceReinit callback function
   * TODO: Documentation
   * @endif
   */
  void LocalServiceActionListenerHolder::
  postServiceReinit(coil::Properties& prop, RTM::LocalServiceBase* service)
  {
    LISTENERHOLDER_CALLBACK(postServiceReinit, (prop, service));
  }
  
  /*!
   * @if jp
   * @brief postServiceFinalize R[obN֐
   * TODO: Documentation
   * @else
   * @brief postServiceFinalize callback function
   * TODO: Documentation
   * @endif
   */
  void LocalServiceActionListenerHolder::
  postServiceFinalize(std::string service_name, RTM::LocalServiceBase* service)
  {
    LISTENERHOLDER_CALLBACK(postServiceFinalize, (service_name, service));
  }
  
  /*!
   * @if jp
   * @brief preServiceFinalize R[obN֐
   * TODO: Documentation
   * @else
   * @brief preServiceFinalize callback function
   * TODO: Documentation
   * @endif
   */
  void LocalServiceActionListenerHolder::
  preServiceFinalize(std::string service_name, RTM::LocalServiceBase* service)
  {
    LISTENERHOLDER_CALLBACK(preServiceFinalize, (service_name, service));
  }
  
};
